program tomo_op
use sep
use sep3d_struct_mod
use basic_util_mod
use tomo_inverse_mod
implicit none
type(sep3d)       ::  slow_s
integer           :: n(3)
integer,external  :: sreed,srite
real              :: o(3),d(3)
real, allocatable :: slow(:)
real, pointer     :: err0(:),reg0(:),dat0(:)

  call sep_init(SOURCE)

  call init_sep3d("in",slow_s,"INPUT")
  call set_n_o_d_3d(slow_s,n,o,d)
  allocate(slow(product(n)))

  if(4*size(slow)/=sreed("in",slow,size(slow)*4)) &
    call seperr("trouble reading in slowness model")

  if(.not. load_mask_op(slow_s))& !done
    call seperr("trouble loading mask operator")

  if(.not. load_tomo_op(slow_s,err0)) &
    call seperr("trouble reading in tomo_op")

  if(.not. load_wt_op(err0))& !done
    call seperr("trouble reading in wt operator")

  if(.not. load_eps_op(slow_s))& !done
    call seperr("trouble initalizing eps_op")

  if(.not. load_reg_prec(slow_s,reg0)) &  !done
    call seperr("trouble loading reg_prec")

  if(.not. load_mask_op(slow_s))&  !done
    call seperr("trouble initalizing mask_op")


write(0,*) "  A 4 A",sum(err0),sum(reg0)
  if(.not. init_chains(err0,reg0,dat0)) & !done
    call seperr("trouble initializing chains")

write(0,*) "  A 5fA",sum(dat0)
  if(.not. init_solver())& !done
    call seperr("trouble initializing solver")

write(0,*) "  A 5 A"
  if(.not. run_solver(dat0,slow)) & !done
    call seperr("trouble running solver")
write(0,*) "  A 6 A"

  if(4*size(slow)/=srite("out",slow,size(slow)*4)) &
    call seperr("trouble writing out slowness model")

end program
