program tomo_prog
  use traceback_mod
  use sep3d_struct_mod
  use sep
  use verb_mod
  implicit none
  type(sep3d)          :: ray_s,slow_w,junk_s
  logical              :: tau
  integer              :: n(3),ngather,i1
  integer              :: nh,f,block,nb,iray
  real                 :: o(3),d(3),p2a,fact,alpha,sc,tot1,tot2,tot,tot4
  real,allocatable     :: rays(:,:,:),junk(:)
  real,allocatable     :: gamma(:),theta(:),posz(:),slow(:),dipx(:),dipy(:),posx(:)
  integer, allocatable :: iloc(:,:,:),n1(:),ipos(:)
  real, allocatable    :: scale(:,:,:),fract(:,:,:),tr_scale(:),spos(:),var(:)


  call sep_init()
  call init_3d()
  call init_sep3d("in",ray_s,"INPUT")
  call from_param("tau",tau,.false.)
  p2a=atan(1.)/45.

  if(.not. init_verbose()) call seperr("trouble initializing verbose")

  if(.not. init_traceback_func("slow","sigma_x","sigma_y",ray_s%d(1))) &
    call seperr("trouble initializing traceback function")

  ngather=ray_s%n(2)*ray_s%n(3)
  allocate(rays(3,ray_s%n(1)/3,ngather))
  allocate(gamma(ngather),theta(ngather))
  allocate(iloc(3,ray_s%n(1),ngather),scale(3,ray_s%n(1),ngather))
  allocate(n1(ngather),fract(3,ray_s%n(1),ngather),tr_scale(ngather))
  allocate(slow(ngather),posx(ngather),posz(ngather),dipx(ngather),dipy(ngather),var(ngather))
  allocate(ipos(ngather*8*ray_s%n(1)/3))
  allocate(spos(ngather*8*ray_s%n(1)/3))

 if(.not. init_print_progress(0,ray_s%n(4))) &
   call seperr("trouble initialzing print progress")


  tot2=0.
  tot1=0.
  do f=1,ray_s%n(4)
    call print_progress("rays->operator")
    call sep3d_grab_headers("in",ray_s,nh,nwind=(/ray_s%n(2),ray_s%n(3),1/),&
      fwind=(/0,0,f-1/))
    call sep3d_grab_key_vals(ray_s,"gamma",gamma)
    call sep3d_grab_key_vals(ray_s,"vel",slow);slow=1./slow
    call sep3d_grab_key_vals(ray_s,"pos_x",posx)
    call sep3d_grab_key_vals(ray_s,"pos_z",posz)
    call sep3d_grab_key_vals(ray_s,"theta",theta);theta=theta*p2a
    call sep3d_grab_key_vals(ray_s,"dip_x",dipx)
    call sep3d_grab_key_vals(ray_s,"dip_y",dipy)
    call sep3d_grab_key_vals(ray_s,"var",var)
    fact=posz(1)*(1.-gamma(1))*slow(1)
    if(.not. sep3d_read_data('in',ray_s,rays)) &
      call seperr("trouble reading in data")
    alpha=atan(dipx(1))
    do iray=1,nh
      !for now the 1-D dip
      if(tau) then
        if(.not. trace_back_tau(rays(:,:,iray),1.,scale(:,:,iray),&
          iloc(:,:,iray),fract(:,:,iray),n1(iray)))&
          call seperr("trouble tracing back tau")
      else
        if(.not. trace_back_depth(rays(:,:,iray),1.,scale(:,:,iray),&
          iloc(:,:,iray),fract(:,:,iray),n1(iray)))&
          call seperr("trouble tracing back depth")
      end if
      tr_scale(iray)=fact*sin(theta(iray))**2/&
        (cos(alpha)*(cos(alpha)**2-sin(theta(iray))**2))
      tr_scale(iray)=fact*sin(theta(iray))**2/&
        (cos(alpha)*(cos(alpha)**2-sin(theta(iray))**2))
    end do
    call add_traceback(scale,iloc,fract,nh,n1,tr_scale,ipos,spos,var)
  end do
  call finish_tracebacks()
end program
