module tomo_chain_mod
use tomo_wt_mod
use tomo_eps_mod
use dottest;
use tomo_mask_mod
use tomo_op_mod
use tomo_reg_prec_mod
use tomo_eps_mod
use tomo_reg_prec_mod
implicit none
integer, private, save :: nfit,nstyle1
logical, private, save :: prec
real, pointer, private, save :: tempm(:),temp1(:)

contains

logical function init_chains(gam0,reg0,dat0)
  real, pointer :: gam0(:),reg0(:),dat0(:)
  integer :: ierr
  integer :: nm 
  init_chains=.false.

  call from_param("prec",prec,.true.)

  nstyle1=size(reg0)
  nfit=wt_range()
  nm=reg_domain()
  allocate(tempm(nm))
  allocate(dat0(nstyle1+nfit))
  dat0=0
  ierr=eps_op(.false.,.false.,reg0,dat0)
  dat0(nfit+1:)=dat0(1:size(reg0))
  ierr=wt_op(.false.,.false.,gam0,dat0)
  allocate(temp1(max(size(gam0),nm)))
  deallocate(gam0,reg0)
  init_chains=.true.
end function


integer function m_p(adj,add,model,data)
logical,intent(in) :: adj,add
real               :: model(:),data(:)
m_p=0
if (prec) then
  call chain(mask_op,prec_op,adj,add,model,data,temp1)
else
  m_p=mask_op(adj,add,model,data)
end if
end function

logical function chain_dot()
chain_dot=.false.
if(.not. my_dot(m_p,size(tempm),size(tempm))) then
   write(0,*) "failed m_p"
   return
end if
if(.not. my_dot(wt_op,wt_domain(),wt_range())) then
   write(0,*) "failed wt_op"
   return
end if
write(0,*) "BEFOR TOMO CHECK",size(tempm),wt_domain()
if(.not. my_dot(tomo_op,size(tempm),wt_domain())) then
   write(0,*) "failed tomo_op"
   return
end if
if(.not. my_dot(model_styling_op,size(tempm),size(tempm))) then
   write(0,*) "failed model_styling_op"
   return
end if

chain_dot=.true.
end function

logical function my_dot(oper,nmod,ndat)
  integer :: nmod,ndat
   interface 
     integer function oper(adj,add,model,data)
       logical, intent(in) :: adj,add
       real :: model(:),data(:)
     end function 
   end interface
   real :: dot1(2),dot2(2)

   my_dot=.true.
   call dot_test(oper,nmod,ndat,dot1,dot2)
   if(abs(dot1(1)/dot1(2)-1.)>.02) my_dot=.false.
   if(abs(dot2(1)/dot2(2)-1.)>.02) my_dot=.false.
   if(.not. my_dot) write(0,*) dot1,dot2
  

end function




integer function w_t(adj,add,model,data)
logical,intent(in) :: adj,add
real               :: model(:),data(:)
w_t=0
call chain(wt_op,tomo_op,adj,add,model,data,temp1)
end function

integer function data_fitting_op(adj,add,model,data)
logical,intent(in) :: adj,add
real               :: model(:),data(:)
data_fitting_op=0
call chain(w_t,m_p,adj,add,model,data,tempm)
end function

integer function model_styling_op(adj,add,model,data)
logical,intent(in) :: adj,add
real               :: model(:),data(:)

if(.not. prec) then
  call chain(eps_op,reg_op,adj,add,model,data,tempm)
  model_styling_op=0
else 
  model_styling_op=eps_op(adj,add,model,data)
end if
end function

integer function op(adj,add,model,data)
logical,intent(in) :: adj,add
real               :: model(:),data(:)

call array(data_fitting_op,model_styling_op,adj,add,model,data(1:nfit),&
  data(nfit+1:))
op=0

end function






end module
