module tomo_inverse_mod
use sep
use sep3d_struct_mod
use tomo_chain_mod
use bob_solver_mod
use cgstep_mod
implicit none
logical,private, save :: prec,verb,dot
integer, private, save :: niter

contains

logical function init_solver()

init_solver=.false.

call from_param("niter",niter,50)
call from_param("prec",prec,.true.)
call from_param("dot",dot,.false.)
call from_param("verb",verb,.false.)

init_solver=.true.
end function

logical function run_solver(data,model)
real :: model(:),data(:)
real,allocatable :: dm(:),junk(:),junk2(:)
integer :: ierr
run_solver=.false.
allocate(dm(size(model)))
allocate(junk(size(model)))
if(dot) then
  if(.not. chain_dot() ) call seperr("didn't pass dot test")
end if 
    
allocate(junk2(size(data)))
call bob_solver( junk,data, op, cgstep, niter,resd=junk2,verb=verb)
ierr=prec_op(.false.,.false.,junk,model)
call srite("res.H",data,size(data)*4)
call srite("res.H",-junk2,size(junk2)*4)
run_solver=.true.
end function






end module
