module tomo_mask_mod
use sep
use adj_mod
use sep3d_struct_mod
implicit none
real, private, save,  pointer :: wts(:)
integer, private,save :: ndomain,nrange


contains
logical function load_mask_op(slow_s)
type(sep3d) :: slow_s,wt_s
integer, external :: auxin,sreed

load_mask_op=.false.
ndomain=product(slow_s%n(1:sep3d_ndims(slow_s)))
if(-1==auxin("mask")) then
 allocate(wts(product(slow_s%n(1:sep3d_ndims(slow_s)))))
 wts=1
else
 call init_sep3d("mask",wt_s,"INPUT")
 allocate(wts(product(wt_s%n(1:sep3d_ndims(wt_s)))))
 if(4*size(wts)/=sreed("mask",wts,size(wts)*4)) then
   write(0,*)"trouble loading mask_op"
   return
 end if
end if

nrange=size(wts)
load_mask_op=.true.
end function

integer function mask_range()
 mask_range=nrange
end function

integer function mask_domain()
 mask_domain=ndomain
end function

integer function mask_op(adj,add,model,data)
logical,intent(in) :: adj,add
real    :: model(:),data(:)

call adjnull(adj,add,model,data)
if(.not. adj) then
  data=data+model*wts
else 
  model=model+data*wts
end if
mask_op=0

end function


end module
