module tomo_reg_prec_mod
use sep
use nhelicon2
use npolydiv2
use nhelicon
use tomo_eps_mod
use npolydiv
use chain_mod
use sep3d_struct_mod
use io_nfilt
implicit none
logical, private, save :: prec,dual
real, private,save,pointer :: space(:)
type(nfilter) :: filt1,filt2
integer, private, save :: nmod


contains


logical function load_reg_prec(slow_s,reg0) 
type(sep3d)   :: slow_s,reg_s
real, pointer :: reg0(:),junk(:)
integer, external :: auxin,sreed
integer :: ierr

load_reg_prec=.false.

nmod=product(slow_s%n(1:sep3d_ndims(slow_s)))

  allocate(junk(nmod))
  allocate(reg0(nmod))
if(-1==auxin("reg0")) then
  junk=0.
else
  call init_sep3d("reg0",reg_s,"INPUT")
  if(4*size(junk)/=sreed("reg0",junk,size(junk)*4)) then
    write(0,*) "trouble reading in reg0"
    return
  end if
end if

call from_param("prec",prec,.true.)
if(0==auxin("filt")) then
  write(0,*) "filt not supplied"
  return
end if
if(.not. read_nfilt("filt",filt1)) then
  write(0,*) "trouble reading nfilter"
  return
end if
dual=.false.
if(-1/=auxin("filt2")) then
  dual=.true.
  if(.not. read_nfilt("filt2",filt2)) then
    write(0,*) "trouble reading nfilter"
    return
  end if
  allocate(space(nmod))
end if
if(prec) then
  call npolydiv_init(nmod,filt1)
  if(dual) call npolydiv2_init(nmod,filt2)
else
  call nhelicon_init(filt1)
  if(dual) call nhelicon2_init(filt2)
end if

ierr=eps_op(.false.,.false.,junk,reg0)
write(0,*) "TEST THS",sum(junk),sum(reg0)
deallocate(junk)
!reg0=0.
load_reg_prec=.true.
end function

integer function prec_op(adj,add,model,data)
logical, intent(in) :: adj,add
real :: model(:),data(:)
prec_op=0
if (prec) then
  if(dual) then
    call chain(npolydiv_lop,npolydiv2_lop,adj,add,model,data,space)
  else
    prec_op=npolydiv_lop(adj,add,model,data)
  end if
else 
  data=model
end if
end function

  
integer function reg_range()
reg_range=nmod
end function

integer function reg_domain()
reg_domain=nmod
end function

integer function prec_range()
prec_range=nmod
end function

integer function prec_domain()
prec_domain=nmod
end function


integer function reg_op(adj,add,model,data)
logical, intent(in) :: adj,add
real :: model(:),data(:)
integer :: ierr



reg_op=0
if(dual) then
  call chain(nhelicon_lop,nhelicon2_lop,adj,add,model,data,space)
else
  ierr=nhelicon_lop(adj,add,model,data)
end if


end function

  






end module
