import re,string
import SEP.util
import SEP.spawn
import SEP.par


def extract_pars(pars,prefix,out=None):
  if not out: out=SEP.par.sep_par(name=prefix)
  srS=re.compile("%s(\S+)"%prefix)
  for key,val in pars.return_dict().items():
    b=srS.search(key)
    if b: 
      out.add_param(b.group(1),val)
      del pars[key]
  return out,pars
                                                                                                    
def add_pars(par_big,par_small,prefix):
  for key,val in par_small.return_dict().items():
    par_big.add_param("%s%s"%(prefix,key),val)
  return par_big

def logic(par): 
  par=str(par)
  if par[0]=='0' or par[0]=='n' or par[0]=="N": return  None
  if par[0]=='1' or par[0]=='y' or par[0]=="Y": return  1
  else: return  int(par)


class tomo_obj:
  def __init__(self,name,**kw):
    self.name=name
    self.kw={}
    self.kw=self.update_defaults(kw)
    self.set_defaults(kw)
    self.current=self.kw
    self.flow=[]
    self.temp=[]
    self.results=[]
    self.files={}


  def add_command(self,com,par=None,results=None,temp=None):
    command=com.split()
    if par:
      command.extend(self.par(par,kuse=self.current,err=1).return_par_list())
    if temp: 
      for file in temp: 
        if file: self.temp.append(file)
    if results: 
      for file in results: 
        if file: self.results.append(file)
    self.flow.append(string.join(command))

  def add_temp(self,file):
   self.temp.append(file)

  def return_commands(self):
    return self.flow

  def clear(self):
    self.temp=[]
    self.results=[]
    self.flow=[]

  def run_com(self):
    logit=logic(self.par("logit",1,kuse=self.current))
    verb=logic(self.par("verb",0,kuse=self.current))
    logfile=None
    for com in self.return_commands(): 
      if logit: logfile=SEP.util.temp_file()
      SEP.spawn.run_wait(com,logfile=logfile,error=1,verb=verb)

  def set_defaults(self,kw):
    """Set the defaults"""
#    self.kw={}
 
  def iter(self,ident,**kw):
    SEP.util.err("Setup how to do an iteration")
                                                                                                    
  def update_current(self,**kw):
    return self.update_database(kw,self.current)

  def update_database(self,kin,kout):
    for key,val in kin.items():
      kout[key]=val
    list=self.par("par_struct",kuse=kout)
    if list:
      for name in list:
        srS=re.compile("%s(\S+)"%name)
        pars=self.par(name,kuse=kout)
        if pars:
          for key,val in kout.items():
            b=srS.search(key)
            if b:
              kout[name].add_param(b.group(1),val)
    return kout


  def update_defaults(self,kw):
    return self.update_database(kw,self.kw)

    
  def add_clean(self):
    self.add_command("Rm3d %s"%string.join(self.temp))
                                                                                                    
  def cpar(self,r,default=None,err=None):
    return self.par(r,default,err,kuse=self.current)

  def new_file(self,name,file):
    self.files[name]=file

  def file(self,name,err=1):
    file=self.par(name,kuse=self.files)
    if not file: 
      file=self.cpar(name,err=err)
    return file
    
  def return_files(self):
    new_list={}
    for key, val in self.files.items():
      if self.temp.count(val)==0:  new_list[key]=val
    return new_list

  def par(self,r,default=None,err=None,kuse=None):
    if kuse: k=kuse
    else: k=self.kw
    if k.has_key(r): return k[r]
    elif default:
      k[r]=default
      return default
    elif err: SEP.util.err("Missing required parameter %s in %s"%(r,self.name))
    else: return default

                                                                                                    
def image_args(args,data,vel):
  D=SEP.superset.superset(file=data)
  S=SEP.superset.superset(file=vel)
  n,o,d,label,unit=D.axis(1)
  args.add_string("amx_n=%d amx_o=%f amx_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(2)
  args.add_string("amy_n=%d amy_o=%f amy_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(3)
  args.add_string("ahx_n=%d ahx_o=%f ahx_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(4)
  args.add_string("ahy_n=%d ahy_o=%f ahy_d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=D.axis(5)
  args.add_string("aw__n=%d aw__o=%f aw__d=%f"%(int(n),float(o),float(d)))
  n,o,d,label,unit=S.axis(1)
  args.add_param("az__n",args.par("az__n",n)[0])
  args.add_param("az__o",args.par("az__o",o)[0])
  args.add_param("az__d",args.par("az__d",d)[0])
  args.add_param("D",data)
  args.add_param("S",vel)
  return args
                                                                                                    


class mig_obj(tomo_obj):
  def __init__(self,name,**kw):
    tomo_obj.__init__(self,name,**kw)


  def set_defaults(self,kw):
#    self.kw={}
    self.default_lloyd()
    self.default_image()
    self.default_ang()
    self.kw["par_struct"]=["imageP_","angP_"]

  def default_lloyd(self):
    self.kw["lloydP_"]=SEP.par.sep_pars(name="lloydP_")
    self.kw["lloydP_"].add_param("nref",4)

  def default_image(self):
    self.kw["imageP_"]=SEP.par.sep_pars(name="imageP_")
    self.kw["imageP_"].add_param("nref",4)
    self.kw["imageP_"].add_param("velocity","y")
    self.kw["imageP_"].add_param("image_real","y")

  def default_ang(self):
    self.kw["angP_"]=SEP.par.sep_pars(name="angP_")



  def prep(self,ident):

    vel_file=self.file("vel_in")

    vel=SEP.superset.superset(file=vel_file)
    data_file=self.file("data")
    vel_file=self.file("vel_in")
    image_par=image_args(self.cpar("imageP_",err=1),data_file,vel_file)
    self.cpar("imageP_").add_pars(image_par)

    n3out=int(image_par.par("az__n",error=1)[0])
    o3out=float(image_par.par("az__o",error=1)[0])
    d3out=float(image_par.par("az__d",error=1)[0])
    i="n3out=%d o3out=%f d3out=%f"%(n3out,o3out,d3out)

    v="vel_mig.%s.H"%ident
    if vel.ndims()==2:
      self.add_command("Transp<%s|Transp plane=23|Interp %s>%s"%(vel_file,i,v),
      temp=[v])
    else:
      self.add_command("Transp<%s plane=13|Interp %s"%(vel_file,v,i),temp=[v])
  
    schoice="schoice.%s.H"%ident
    self.add_command("Lloyd_vel.x <%s >%s"%(v,schoice),par="lloydP_",
     temp=[schoice])

    self.new_file("schoice",schoice)
    self.new_file("vel_mig",v)
    
  def iter(self,ident,**kw):
    self.update_current(**kw)
    clean=logic(self.cpar("clean",0))
    self.files=self.cpar("files",{})


    self.prep(ident)
    self.migrate(ident)
    self.ang(ident)
    return self.return_files()



  def migrate(self,ident):


    vel_mig=self.file("vel_mig",err=1)
    schoice=self.file("schoice",err=1)
    image="image.%s.H"%ident


    self.current["imageP_"].add_param("R",image)
    self.current["imageP_"].add_param("S",vel_mig)
    self.current["imageP_"].add_param("schoice",schoice)

    restart=logic(self.cpar("restart"))
    self.current["imageP_"].add_param("prog",self.cpar("program",err=1))

    if restart: self.current["imageP_"].add_param("restart",1)
    self.add_command("image.py",par="imageP_",results=[image])

    image0="image_zero.%s.H"%ident

    self.add_command("Window3d < %s  min3=0 n3=1 |Transp >%s"%(image,image0),
      results=[image0])

    self.new_file("image",image)
    self.new_file("image0",image0)


  def ang(self,ident):

    image=self.file("image")
    mig="mig.%s.H"%ident

    temp="im_reshape.%s.H"%ident
    self.add_command("Transp < %s reshape=2,4,5 plane=13 >%s"%(image,temp),
       temp=[temp])
    self.add_command("OFF2ANG <%s  >%s"%(temp,mig), results=[mig],par="angP_")
    self.new_file("mig",mig)


class gamma_obj(tomo_obj):
  def __init__(self,name,**kw):
    tomo_obj.__init__(self,name,**kw)

  def semb_com(self,ident):

    image0=self.file("image0")
    mig=self.file("mig")

    dipx="dip_xz.%s.H"%ident
    self.add_command("Dip < %s  >%s"%(image0,dipx),
       par="dipP_",results=[dipx])

    if not self.is_2d:
      dipy="dip_yz.%s.H"%ident
      self.add_command("Transp <%s plane=23 |Dip  >%s"%(image0,dipy),par="dipP_",results=[dipy])
    else: dipy="none"

    vel=self.file("vel_in")
    data=self.file("data")
    migs=SEP.superset.superset(file=data)
    aaa=image_args(SEP.par.sep_pars(name="AA"),data,vel)
    n1=int(aaa.par("az__n",error=1)[0])
    n2=int(aaa.par("ahx_n",error=1)[0])
    n3=int(aaa.par("ahy_n",error=1)[0])
    n4=int(aaa.par("amx_n",error=1)[0])
    n5=int(aaa.par("amy_n",error=1)[0])

    mask=self.cpar("mask",err=1)

    mask_math="mask_math.%s.H"%ident
    self.add_command("Math file2=%s file1=%s exp='file1*file2'  >%s"%(mask,
       mig,mask_math), temp=[mask_math])

    semb_temp="semb_temp.%s.H"%ident
    semb_pars=["command=semb_drive.x tags='intag,outtag,dips'"]
    semb_pars.append('usage=\"INPUT,OUTPUT,INPUT\" axis=\"4,4,5\"')
    semb_pars.append('file_type=\"BLOCK,BLOCK,COPY\"')
    semb_pars.append('files=\"%s,%s,dip_xz.%s.H\"'%(mask_math, semb_temp,ident))
    semb_pars.append('nsect=%d logdir=\"/scr1/bob/semb\" '%(int(n4)/25))
    self.add_command("Parallel %s"%string.join(semb_pars),
       temp=[semb_temp],par="sembP_")

    semb="semb.%s.H"%ident
    self.add_command("Window 3d < %s >%s"%(semb_temp,semb),results=[semb])

    self.new_file("dip_xz",dipx)
    self.new_file("dip_yz",dipy)
    self.new_file("semb",semb)


  def reduce_com(self,ident):

    dipx=self.file("dip_xz")
    dipy=self.file("dip_yz")
    image0=self.file("image0")
    semb=self.file("semb")

    image0_reduce="image0_reduce.%s.H"%ident
  
    self.add_command("reduce_it.x< %s >%s"%(image0,image0_reduce),
        temp=[image0_reduce],par="reduceP_")

    dipx_reduce="dip_xz_reduce.%s.H"%ident
    dipy_reduce="dip_yz_reduce.%s.H"%ident
    self.add_command("reduce_it.x < %s >%s"%(dipx,dipx_reduce),
      temp=[dipx_reduce],par="reduceP_")
    if not self.is_2d:
      self.add_command("reduce_it.x < %s >%s"%(dipy,dipy_reduce),
        temp=[dipy_reduce],par="reduceP_")

    semb_reduce="semb_reduce.%s.H"%ident
    self.add_command("Transp plane=23 < %s | reduce_it.x %s |Smooth  >%s"%(semb,
      self.current["reduceP_"].return_par_string(),semb_reduce),temp=[semb_reduce],par="sembP_")
    self.new_file("image0_r",image0_reduce)
    self.new_file("dip_xz_r",dipx_reduce )
    self.new_file("dip_yz_r",dipy_reduce )
    self.new_file("semb_r",semb_reduce )
                                                                                                    
   
  def iter(self,ident,**kw):
    self.update_current(**kw)
    clean=logic(self.cpar("clean",0))
    verb=logic(self.cpar("verb",0))
    self.files=self.cpar("files",err=1)

    self.semb_com(ident)
    self.reduce_com(ident)
    self.gamma_var_com(ident)

    if clean: self.add_clean()
    return self.return_files()


  def gamma_var_com(self,ident):

    image0_reduce=self.file("image0_r")
    dipx_reduce=self.file("dip_xz_r")
    dipy_reduce=self.file("dip_yz_r")
    semb_r=self.file("semb_r")
    var="var.%s.H"%ident
    gamma="gamma.%s.H"%ident
 
    dip_semb="dip_semb.%s.H"%ident
    self.add_command("Dip < %s  >%s"%(image0_reduce,dip_semb),
      par="dipP_",temp=[dip_semb])
                                                                                
    filt_semb="filt_semb.%s.H"%ident
    self.add_command("Model_covar.x < %s dip_xz=%s >%s"%(image0_reduce,dip_semb,      filt_semb),par="filtP_",temp=[filt_semb])
                                                                                
    self.add_command("Newpick_rand.x<%s var=%s image=%s nfilt=%s >%s"%(semb_r,
      var,image0_reduce,filt_semb,gamma),results=[gamma,var],par="pickP_")

    self.new_file("gamma",gamma)
    self.new_file("var",var)
                                                                                                    
  def default_dip(self):
    self.kw["dipP_"]=SEP.par.sep_pars(name="dipP_")

  def default_semb(self):
    self.kw["sembP_"]=SEP.par.sep_pars(name="sembP_")
    self.kw["sembP_"].add_string("nsmooth=12 ogam=.7 dgam=.005 ngam=121")

  def default_reduce(self):
    self.kw["reduceP_"]=SEP.par.sep_pars(name="reduceP_")
    v=SEP.superset.superset(file=self.par("vel_in",err=1,kuse=self.kw))
    self.kw["reduceP_"].add_string("rect1=8 rect2=5 rect3=5")
    n1,o1,d1,label,unit=v.axis(1)
    n2,o2,d2,label,unit=v.axis(2)
    n3,o3,d3,label,unit=v.axis(3)
    if d1>1:
      s1=30.
      s2=60.
      s3=60
    else:
      s1=.03
      s2=.06
      s3=.06
    n1=o1+(d1*(n1-1))/s1
    n2=o2+(d2*(n2-1))/s2
    n3=o3+(d3*(n3-1))/s3
    if n3==0: n3=1
    self.is_2d=None
    if n3==1: self.is_2d=1
    self.kw["reduceP_"].add_string("ns=%d,%d,%d"%(n1,n2,n3))
    self.kw["reduceP_"].add_string("os=%f,%f,%f"%(o1,o2,o3))
    self.kw["reduceP_"].add_string("ds=%f,%f,%f"%(s1,s2,s3))

  def set_defaults(self,kw):
#    self.kw={}
    self.default_dip()
    self.default_semb()
    self.default_reduce()
    self.default_pick()
    self.kw["par_struct"]=["pickP_","reduceP_","sembP_","dipP_"]

  def default_pick(self):
    self.kw["pickP_"]=SEP.par.sep_pars(name="pick_pars")
    self.kw["pickP_"].add_string("range_min=.08 range_max=.16 eps_min=.4 eps_max=.7")
    self.kw["pickP_"].add_string("nl_iter=9 pow=1.")
    self.default_filt()

  def default_filt(self):
    self.kw["filtP_"]=SEP.par.sep_pars(name="filtP_")
    self.kw["filtP_"].add_string("dip_range=45.")



class rand_obj(gamma_obj):
  def __init__(self,name,**kw):
    tomo_obj.__init__(self,name,**kw)

  def gamma_var_com(self,ident):

    image0_reduce=self.file("image0_r")
    semb_reduce=self.file("semb_r")
    var="var.%s.H"%ident
    gamma="gamma.%s.H"%ident

    dip_semb="dip_semb.%s.H"%ident
    self.add_command("Dip < %s  >%s"%(image0_reduce,dip_semb),
      par="dipP_",temp=[dip_semb])

    filt_semb="filt_semb.%s.H"%ident
    self.add_command("Model_covar.x < %s dip_xz=%s >%s"%(image0_reduce,dip_semb,
      filt_semb),par="filtP_",temp=[filt_semb])

    com="Smooth rect2=6 rect3=6 < %s |Transp plane=23 |Randmap.x "%semb_reduce
    self.add_command(com+"  var=%s  filt=%s >%s"%(var,filt_semb,gamma),
      par="pickP_", results=[var,gamma])

    self.new_file("gamma",gamma)
    self.new_file("var",var)


  def default_pick(self):
    self.kw["pickP_"]=SEP.par.sep_pars(name="pick_pars")
    self.kw["pickP_"].add_string("nreal=1 scale=.4 eps=20.")
    self.kw["pickP_"].add_string("nl_iter=9 pow=1.")
    self.default_filt()

  def default_filt(self):
    self.kw["filtP_"]=SEP.par.sep_pars(name="filtP_")
    self.kw["filtP_"].add_string("dip_range=45.")




                                                                                                    
                                                                                                    
class back_obj(tomo_obj):
  def __init__(self,name,**kw):
    tomo_obj.__init__(self,name,**kw)


  def default_tauspace(self):
    self.kw["tspaceP_"]=SEP.par.sep_pars(name="tspaceP_")
    self.vspace=SEP.superset.superset(file=self.par("vel_in",err=1,kuse=self.kw))
    n1,o1,d1,label,unit=self.vspace.axis(1)
    n2,o2,d2,label,unit=self.vspace.axis(2)
    n3,o3,d3,label,unit=self.vspace.axis(3)
    self.data=SEP.superset.superset(file=self.par("data",err=1,kuse=self.kw))

    self.kw["tspaceP_"].add_string("n1out=%d o1out=%f d1out=%f"%(int(n1)/2,float(o1),
     float(d1)*2.))
    self.kw["tspaceP_"].add_string("n2out=%d o2out=%f d2out=%f"%(int(int(n2)*.7),
      float(o2)-float(d2)*.2*int(n2),float(d2)*2.))
    if n3!=1:
      self.kw["tspaceP_"].add_string("n3out=%d o3out=%f d3out=%f"%(int(int(n3)*.7),
        float(o3)-float(d3)*.2*int(n3),float(d3)*2.))
      self.is_2d=None
    else: self.is_2d=1
                                                                                                    

  def default_filter(self):
    self.kw["filterP_"]=SEP.par.sep_pars(name="filterP_")
    self.kw["filterP_"].add_param("method","steer")


  def default_envelope(self):
    self.kw["envP_"]=SEP.par.sep_pars(name="envP_")
    self.kw["envP_"].add_string("tc1=10 tc2=10")

  def default_coher(self):
    self.kw["cohP_"]=SEP.par.sep_pars(name="cohP_")
    self.kw["cohP_"].add_string("nbox=10,10,10")

  def default_pts(self):
    self.kw["ptsP_"]=SEP.par.sep_pars(name="ptsP_")
    self.kw["ptsP_"].add_string("verb=n")

  def default_dip(self):
    self.kw["dipP_"]=SEP.par.sep_pars(name="dipP_")
    self.kw["dipP_"].add_string("eps=.01 eps2=.01")

  def default_ray(self):
    self.kw["rayP_"]=SEP.par.sep_pars(name="rayP_")
    self.kw["rayP_"].add_string("verb=n")

  def default_band(self):
    self.kw["bandP_"]=SEP.par.sep_pars(name="bandP_")
    self.kw["bandP_"].add_string("fhi=8")

  def default_tomo(self):
    self.kw["tomoP_"]=SEP.par.sep_pars(name="tomoP_")
    n,o,d,label,unit=self.data.axis(3)
    self.kw["tomoP_"].add_string="prec=y niter=60 eps=1. max_off=%f"%(((n-1)*d+o)*2.)

  def set_defaults(self,kw):
    self.kw=kw
    self.default_tauspace()
    self.default_filter()
    self.default_envelope()
    self.default_coher()
    self.default_pts()
    self.default_dip()
    self.default_ray()
    self.default_eps()
    self.default_tomo()
    self.default_band()
    self.default_tau()
    self.default_tomo_op()
    self.default_clip()
    self.kw["par_struct"]=["tspaceP_","tomoP_","tauP_","filterP_","ptsP_"]
    self.kw["par_struct"].extend(["envP_","cohP_","rayP_","t_oP_","epsP_"])

  def default_clip(self):
    self.kw["min_vel"]=1.4
    self.kw["max_vel"]=9999.

  def default_eps(self):
    self.kw["epsP_"]=SEP.par.sep_pars(name="epsP_")

  def default_tomo_op(self):
    self.kw["t_oP_"]=SEP.par.sep_pars(name="t_oP_")

  def default_tau(self):
    self.kw["tauP_"]=SEP.par.sep_pars(name="tauP_")
    self.kw["tauP_"].add_string("tau=n")

  def tomo_space(self):
    a=SEP.superset.superset(name="aa")
    b=self.cpar("tspaceP_",err=1)
    a.set_axis(1,b.par("n1out",error=1)[0],b.par("o1out",error=1)[0],
       b.par("d1out",error=1)[0],"","")
    a.set_axis(2,b.par("n2out",error=1)[0],b.par("o2out",error=1)[0],
        b.par("d2out",error=1)[0],"","")
    if b.par("n3out")[1]:
      a.set_axis(3,b.par("n3out",error=1)[0],b.par("o3out",error=1)[0],
       b.par("d3out",error=1)[0],"","")
    if self.ctau():
      a.set_axis(1,self.cpar("ntau",err=1)[0],self.cpar("otau",err=1)[0],
        self.cpar("dtau",err=1)[0],"","")
    return a

  def build_tomo_space_files(self,ident):
    #convert velocity to tomo space

    vel=self.file("vel_in")
    vel_tomo,velz_tomo=self.convert_tomo_space(vel,ident,"vel")

    image0=self.file("image0");
    junk,junkz=self.convert_tomo_space(image0,ident,"image_zero")

    image0_tomo="image_zero_b.%s.H"%ident
    self.add_command("Bandpass < %s >%s "%(junk,image0_tomo), par="bandP_",
     temp=[image0_tomo])


    dipx_tomo="dip_xz_tomo.%s.H"%ident
    coher_tomo="coher_tomo.%s.H"%ident

    self.add_command("Dip < %s >%s"%(image0_tomo,dipx_tomo),
      par="dipP_",temp=[dipx_tomo]) 
    self.add_command("Coher.x < %s>%s"%(image0_tomo,coher_tomo),
      par="cohP_",temp=[coher_tomo]) 

    if  not self.is_2d: 
      dipy_tomo="dip_yz_tomo.%s.H"%ident
      self.add_command("Transp < %s plane=23 |Dip  >%s"%(image0_tomo,
       dipy_tomo), par="dipP_",temp=[dipy_tomo]) 
    else: dipy_tomo="none"

    slow_tomo="slow_tomo_in.%s.H"%ident
    self.add_command("Math file1=%s >%s exp='1.0/file1'"%(vel_tomo,
      slow_tomo), temp=[slow_tomo])

    self.new_file("velz_tomo",velz_tomo)
    self.new_file("vel_tomo",vel_tomo)
    self.new_file("slow_tomo",slow_tomo)
    self.new_file("image0_tomo",image0_tomo)
    self.new_file("dip_xz_tomo",dipx_tomo)
    self.new_file("dip_yz_tomo",dipy_tomo)
    self.new_file("coher_tomo",coher_tomo)

  def iter(self,ident,**kw):
    self.update_current(**kw)
    clean=logic(self.cpar("clean",0))
    self.files=self.cpar("files",{})

    self.build_tomo_space_files(ident)
    self.filter_com(ident)    #f1,f2
    self.mask_com(ident)      #m
    self.reg0(ident)          #rm0
    self.tomo_op_com(ident)   #build compressed operator form
    self.wt_com(ident)        #W
    self.eps_com(ident)        #eps
    self.tomo(ident)          #tomography
    self.ds_vel(ident)        #back to velocity 
    if clean: self.add_clean()


  def tomo(self,ident):
    #convert to slowness

    slow_tomo=self.file("slow_tomo")
    filt1=self.file("filt1")
    var=self.file("pt_var")
    err=self.file("pt_err")
    nlen=self.file("pt_nlen")
    iloc=self.file("pt_iloc")
    scale=self.file("pt_scale")

    wt=self.file("wt",err=None)
    eps=self.file("eps",err=None)
    rm0=self.file("rm0",err=None)
    filt2=self.file("filt2",err=None)
    mask=self.file("tomo_mask",err=None)
    scale_sigx=self.file("pt_sigx",err=None)
    scale_sigy=self.file("pt_sigy",err=None)

    
    ds="ds.%s.H"%ident
    com=["Tomo.x","< %s >%s"%(slow_tomo,ds)]
    com.append("filt=%s"%filt1)
    if mask: com.append("mask=%s"%mask)
    if filt2: com.append("filt2=%s"%mask)

    com.append("var=%s err=%s nlen=%s iloc=%s scale=%s"%(var,err,nlen,iloc,
      scale))


    if scale_sigx: com.append("scale_sigx=%s"%scale_sigx)
    if scale_sigy: com.append("scale_sigy=%s"%scale_sigy)
    if eps: com.append("eps_file=%s"%eps)
    if wt: com.append("wts=%s"%wt)
    if rm0: com.append("reg0=%s"%rm0)

    self.add_command(string.join(com),results=[ds],par="tomoP_")
    self.new_file("ds",ds)


  def ds_vel(self,ident):
    #convert to velocity
    vel_tomo_out="vel_out.%s.H"%ident
    ds=self.file("ds")
    slow_tomo=self.file("slow_tomo")

    self.add_command("Math file1=%s file2=%s >%s exp='1.0/(file1+file2)'"%(ds,
     slow_tomo,vel_tomo_out), temp=[vel_tomo_out])

    vel_clip="vel_clip.%s.H"%ident
    com="Clip  < %s clip=%s chop=greater |Clip chop=less "%(vel_tomo_out,
     self.cpar("vel_max",err=1))
    self.add_command(com+" clip=%s >%s"%(self.cpar("vel_min",err=1),vel_clip),
      temp=[vel_clip])

    n1,o1,d1,label,unit=self.vspace.axis(1)
    n2,o2,d2,label,unit=self.vspace.axis(2)
    n3,o3,d3,label,unit=self.vspace.axis(3)
    vel_out="vel.%s.H"%ident
    if self.ctau():
      com="Vel_z_tau.x < %s op=vel_z n1=%d o1=%f d1=%f "%(vel_clip,n1,o1,d1)
      com=com+"|Interp n2out=%d o2out=%f d2out=%f"%(n2,o2,d2)
      com=com+" n3out=%d o3out=%f d3out=%f >%s"%(n3,o3,d3)
      com=com+" n1out=%d o1out=%f d1out=%f >%s"%(n1,o1,d1)
    else: 
      com="Interp n2out=%d o2out=%f d2out=%f"%(n2,o2,d1)
      com=com+" n3out=%d o3out=%f d3out=%f "%(n3,o3,d3)
      com=com+" n1out=%d o1out=%f d1out=%f  <%s >%s"%(n1,o1,d1,
        vel_clip,vel_out)
    self.add_command(com,results=[vel_out])
    self.new_file("vel_out",vel_out)

  def tomo_op_com(self,ident):
    pts=self.pts_com(ident)  #done
    rays=self.ray_com(ident) #done


    slow=self.file("slow_tomo")
    velz=self.file("velz_tomo")
    rays=self.file("rays")
   
    var="pt_var.%s.H"%ident
    err="pt_err.%s.H"%ident
    nlen="pt_nlen.%s.H"%ident
    iloc="pt_iloc.%s.H"%ident
    scale="pt_scale.%s.H"%ident

    self.new_file("pt_var",var)
    self.new_file("pt_err",err)
    self.new_file("pt_nlen",nlen)
    self.new_file("pt_iloc",iloc)
    self.new_file("pt_scale",scale)

    com=["Tomo_full.x","var=%s"%var,"err=%s"%err,"nlen=%s"%nlen,"iloc=%s"%iloc]
    com.extend(["scale=%s"%scale,"<%s"%rays,"slow=%s"%slow])
    com.append(">/dev/null")

    scale_sigx= None
    scale_sigy= None
    if self.ctau():
      sigx="sigmax.%s.H"%ident
      scale_sigx="scale_sigx.%s.H"%ident

      com.append("scale_sigx=%s"%scale_sigx)
      com.append("sigma_x=%s"%sigx)
      self.new_file("pt_scale_sigx",scale_sigx)
      n,o,d,label,init=self.tomo_space().axis
      tp=" n1=n o1=%f d1=%f"%(n,o,d)
      SEP.util.command("Vel_z_tau.x < %s %s op=sigx_t >%s"%(velz,tp,sigx),
        temp=[sigx])

      if not self.is_2d:
        sigy="sigmay.%s.H"%to
        scale_sigy="scale_sigy.%s.H"%ident

        self.new_file("pt_scale_sigy",scale_sigy)
        SEP.util.command("Vel_z_tau.x < %s %s op=sigy_t >%s"%(velz,tp,sigy),
          temp=[sigy])
        scale_sigx="scale_sigy.%s.H"%to
        com.append("sigma_y=%s"%sigy)
        com.append("scale_sigy=%s"%scale_sigy)

    self.add_command(string.join(com),par="t_oP_",
      temp=[var,err,nlen,scale,scale_sigx,scale_sigy])


  def ray_com(self,ident):
    vel=self.file("vel_in")
    pts=self.file("pts")

    rays="rays.%s.H"%ident
    
    self.add_command("Pts_rays.x < %s vel=%s >%s"%(pts,vel,rays),
      par="rayP_",results=[rays])

    self.new_file("rays",rays)
 

  def pts_com(self,ident):

    image0_tomo=self.file("image0_tomo")
    dipx=self.file("dip_xz_tomo")
    dipy=self.file("dip_yz_tomo")
    coher=self.file("coher_tomo")
    gamma=self.file("gamma")
    slow_tomo=self.file("slow_tomo")

    pts="pts.%s.H"%ident
    env_temp="image_env.%s.H"%ident

    self.add_command("Envelope < %s>%s"%(image0_tomo,env_temp),
      par="envP_",temp=[env_temp])

    com=["Back_pts.x","< %s "%gamma,"dip_xz=%s"%dipx, "vel=%s"%slow_tomo]

    com.append("envelope=%s"%env_temp)
    com.append("dip_coher=%s"%coher);
    com.append("var=var.%s.H"%ident)
    if  not self.is_2d: com.append("dip_yz=%s"%dipy)

    com.append(">%s"%pts)
    self.add_command(string.join(com),results=[pts],par="ptsP_")
    self.new_file("pts",pts)
    


  def reg0(self,ident):
    rm0="rm0.%s.H"%ident
    slow_tomo=self.file("slow_tomo")
    filt1=self.file("filt1")
    self.add_command("Math file1=%s exp='-1.*file1' >neg_slow.%s.H"%(slow_tomo,
      ident),temp=["neg_slow.%s.H"%ident])
    #for now only 1filt
    self.add_command("Cp neg_slow.%s.H %s "%(ident,rm0))
    self.add_command("Nfilt.x model=neg_slow.%s.H data=%s filter=%s"%(ident,rm0,
      filt1), temp=[rm0])
    self.new_file("rm0",rm0)

  def eps_com(self,ident):
    slow_tomo=self.file("slow_tomo")
    eps="eps.%s.H"%ident
    self.add_command("Zfunc.x  < %s > %s"%(slow_tomo,eps),par="epsP_",
      temp=[eps])
    self.new_file("eps",eps)


  def wt_com(self,ident):
    var=self.file("pt_var")
    wt="wt.%s.H"%ident
    self.add_command("Math file1=%s exp='1./(file1+0.001)' > %s"%(var,wt),
      temp=[wt])
    self.new_file("wt",wt)


  def ctau(self):
    return logic(self.cpar("tauP_",err=1).par("tau",error=1)[0])
 

  def convert_tomo_space(self,file_in,ident,tag):

    tau=self.ctau()
    a=self.tomo_space()
    n1,o1,d1,label,unit=a.axis(1)
    n2,o2,d2,label,unit=a.axis(2)

    if tau: pre="_tomot"
    else : pre="_tomo"

    com="Interp < %s >%s%s.%s.H n2out=%d d2out=%f o2out=%f"%(file_in,
     tag,pre,ident,n2,d2,o2)
    if not self.is_2d:
      n3,o3,d3,label,unit=a.axis(3)
      com=com+" n3out=%d o3out=%f d3out=%f "%(n3,o3,d3)
    if not tau: com=com+" n1out=%d o1out=%f d1out=%f "%(n1,o1,d1)
    self.add_command(com,temp=["%s%s.%s.H"%(tag,pre,ident)])
    if tau:
      vel_in=self.cpar("vel_in",err=1)
      ts="n1=%d o1=%f d1=%f"%(n1,o1,d1)
      self.add_command("Vel_z_tau op=field_t < %s %s field=%s%s.%s.H >%s_tomo.%s.H"%(vel_in,
        ts,tag,pre,ident,tag,ident), temp=["%s_tomo.%s.H"%(tag,pre,ident)])
      return "%s_tomo.%s.H"%(tag,ident),"%s_tomot.%s.H"%(tag,ident)
    else:
      return "%s_tomo.%s.H"%(tag,ident),"%s_tomo.%s.H"%(tag,ident)
   
 
  def filter_com(self,ident):

    #only 1 filter for now
    filt="filt.%s.H"%ident
    filt2="filt2.%s.H"%ident
    slow_tomo=self.file("slow_tomo")
    dipx_tomo=self.file("dip_xz_tomo")
    dipy_tomo=self.file("dip_yz_tomo")
    results=[filt]
    self.new_file("filt1",filt)

    com=["Model_covar.x","<%s"%slow_tomo]
    com.append("dip_xz=%s"%dipx_tomo)
    com.append(">%s"%filt)
    if not self.is_2d:
      com.append("dip_yz=%s filt2=%s"%dipy_tomo,filt2)
      result.append(filt2)
      self.new_file("filt2",filt2)
    self.add_command(string.join(com),results=results,par="filterP_")


  
    


  def mask_com(self,ident):
    """Nothing for now"""
