import commands,string,sys
import SEP.par
import SEP.superset
import SEP.wei_oper
import SEP.wei_code
import SEP.spawn
import SEP.util
import bob_tomo
SEP.util.debug=1
class tomo_run:
  def __init__(self,
    general=SEP.par.sep_pars(name="general"),
    mig=SEP.par.sep_pars(name="mig"),
    gamma=SEP.par.sep_pars(name="gamma"),
    back=SEP.par.sep_pars(name="back"),logit=1,verb=1):

    self.logit=logit
    self.verb=verb
    self.back=self.create_back(general,back)
    self.gamma=self.create_gamma(general,gamma)
    self.mig=self.create_mig(general,mig)
    self.flow=[]

  def create_back(self,general,back):
     back.add_pars(general)
     return bob_tomo.back_obj("back",**back.return_dict())
     
  def create_mig(self,general,mig):
     mig.add_pars(general)
     return bob_tomo.mig_obj("mig",**mig.return_dict())

  def create_gamma(self,general,gamma):
     gamma.add_pars(general)
     return  bob_tomo.gamma_obj("gamma",**gamma.return_dict())

  def iter(self,fr,to,**kw):
    files={}
    files["vel_in"]="vel.%s.H"%fr
    files=self.mig_iter(to,files,**kw)
    files=self.gamma_iter(to,files,**kw)
    files=self.back_iter(to,files,**kw)

  def mig_iter(self,to,files,**kw):
    if kw.has_key("mig_args"): 
      self.mig.iter(to,files=files,**key["mig_args"].return_dict())
    else:  files=self.mig.iter(to,files=files)
    self.flow.extend(self.mig.return_commands())
    self.mig.clear()
    return files

  def gamma_iter(self,to,files,**kw):
    if kw.has_key("gamma_args"): 
      files=self.gamma.iter(to,files=files,**kw["gamma_args"].return_dict())
    else:  files=self.gamma.iter(to,files=files)
    self.flow.extend(self.gamma.return_commands())
    self.gamma.clear()
    return files

  def back_iter(self,to,files,**kw):
    if kw.has_key("back_args"): 
      files=self.back.iter(to,files=files, **(kw["back_args"].return_dict()))
    else:  files=self.back.iter(to,files=files)
    self.flow.extend(self.back.return_commands())
    self.back.clear()
    return files

  def run_com(self):
    logfile=None
    for com in self.flow:
      if self.logit: logfile=SEP.util.temp_file()
      SEP.spawn.run_wait(com,logfile=logfile,error=1,verb=self.verb)

  def run(self):
    mig.run_com()
    gamma.run_com()
    back.run_com()


class tomo_mult(tomo_run):
  def __init__(self,
    general=SEP.par.sep_pars(name="general"),
    mig=SEP.par.sep_pars(name="mig"),
    gamma=SEP.par.sep_pars(name="gamma"),
    back=SEP.par.sep_pars(name="back"),logit=1,verb=1):

    tomo_run.__init__(self,general,mig,gamma,back)

  def to_list(self,fr,to_list):
    a=[]
    for t in to_list: a.append("%s.%s"%(fr,t))
    return a

  def  iter_file(self,fr_list,to_list):
    list=[]
    for fr in fr_list: list.extend(self.to_list(fr,to_list))
    return list
      
  def create_gamma(self,general,gamma):
     gamma.add_pars(general)
     return  bob_tomo.gamma_obj("gamma",**gamma.return_dict())

  def iter(self,fr_list,to_list,rand_seed,**kw):
    files={}
    suf_out=[]
    i=0
   
    for fr in fr_list:
      files["vel_in"]="vel.%s.H"%fr
      files=self.mig_iter(fr,files=files,**kw)
      if kw.has_key("gamma_args"): arg=kw["gamma_args"]
      else: arg=SEP.par.sep_pars(name="gamam")

      for to in self.to_list(fr,to_list):
        suf_out.append(to)
        arg.add_param("pickP_seed",rand_seed[i])
        kw["gamma_args"]=arg
        file1=self.gamma_iter(to,files,**kw)
        file1=self.back_iter(to,file1,**kw)
        i=i+1
    return suf_out

