#!/usr/bin/env python
import commands
import string,re,sys
import SEP.par
import SEP.spawn
import SEP.util
import SEP.superset

def extract_pars(pars,prefix):
  out=SEP.par.sep_pars(name=prefix)
  srS=re.compile("%s(\S+)"%prefix)
  for key,val in pars.return_dict().items():
    b=srS.search(key)
    if b: out.add_param(b.group(1),val)
  return out 

args=SEP.par.sep_args()
clean=str(args.par("clean",1)[0])

ident=args.par("ident",error=1)[0]
verb=args.par("verb",0)[0]
if verb==0: verb=None
mig=args.par("migration",error=1)[0]
image0=args.par("image0",error=1)[0]
mask,c_mask=args.par("mask")
gamma=args.par("gamma",error=1)[0]
var=args.par("var",error=1)[0]

temp_files=[]


########
dip="dip.%s.H"%ident
SEP.spawn.run_wait(("Dip < %s  >%s %s"%(image0,dip,
  extract_pars(args,"dip_").return_par_string())).split(),verb=verb,
  logfile=SEP.util.temp_file())

migs=SEP.superset.superset(file=mig)
n1,o1,d1,label,unit=migs.axis(1)
n2,o2,d2,label,unit=migs.axis(2)
n3,o3,d3,label,unit=migs.axis(3)
n4,o3,d3,label,unit=migs.axis(4)
n5,o3,d3,label,unit=migs.axis(5)

if c_mask==0:
  mask="mask.%s.H"%ident
  com="Spike n1=%d n2=%d n3=%d n4=%d n5=%d mag=1 >%s"%(int(n1),int(n2),int(n3),int(n4),int(n5),mask)
  SEP.spawn.run_wait(com.split(),logfile=SEP.util.temp_file(),verb=verb,error=1)


mask_math="mask_math.%s.H"%ident
SEP.spawn.run_wait(("Math file2=%s file1=%s >%s exp='file1*file2'"%(mask,mig,mask_math)),
 logfile=SEP.util.temp_file(),verb=verb,error=1)

semb_temp="semb_temp.%s.H"%ident
semb_pars=SEP.par.sep_pars(name="semb_pars")
semb_pars.add_string("command=semb_drive.x tags='intag,outtag,dips'")
semb_pars.add_string('usage=\"INPUT,OUTPUT,INPUT\" axis=\"4,4,5\"')
semb_pars.add_string('file_type=\"BLOCK,BLOCK,COPY\" files=\"%s,%s,%s\"'%(mask_math,
 semb_temp,dip))
semb_pars.add_string('nsect=%d logdir=\"/scr1/bob/semb\" '%(int(n4)/25))
SEP.spawn.run_wait("Parallel %s %s "%(semb_pars.return_par_string(),
   extract_pars(args,"semb_").return_par_string()), 
 logfile=SEP.util.temp_file(),verb=verb,error=1)


semb="semb.%s.H"%ident
SEP.spawn.run_wait("Window3d < %s >%s"%(semb_temp,semb),error=1,verb=verb)
temp_files.extend([dip,mask_math,semb_temp,semb])

semb_reduce="semb_reduce.%s.H"%ident
reduce_par= extract_pars(args,"reduce_").return_par_string()
SEP.spawn.run_wait("Transp plane=23 < %s | reduce_it.x %s |Smooth %s >%s"%(semb,
   reduce_par,reduce_par,semb_reduce),
   logfile=SEP.util.temp_file(),verb=verb,error=1)

image0_reduce="image0_reduce.%s.H"%ident
dip_reduce="dip_reduce.%s.H"%ident
temp_files.extend([semb_reduce,image0_reduce,dip_reduce])

SEP.spawn.run_wait("reduce_it.x < %s %s >%s"%(dip,reduce_par,dip_reduce),
 logfile=SEP.util.temp_file(),verb=verb,error=1)

SEP.spawn.run_wait("reduce_it.x < %s %s >%s"%(image0,reduce_par,image0_reduce),
 logfile=SEP.util.temp_file(),verb=verb,error=1)

SEP.spawn.run_wait("Newpick.x < %s %s var=%s image=%s dip=%s >%s"%(semb_reduce,
   extract_pars(args,"pick_").return_par_string(),var,image0_reduce,
   dip_reduce,gamma),verb=verb,error=1,logfile=SEP.util.temp_file())
    
   
if clean[0]=='1' or clean[0]=='y' or clean[0]=='Y':
  SEP.spawn.run_wait("Rm3d %s"%string.join(temp_files),logfile=SEP.util.temp_file(),verb=verb)
